#INCLUDE "ti82.h"
#INCLUDE "graph.h"

flag      = TEXT_MEM
compt	  = TEXT_MEM+1

;---------------------Affichage de l'cran de prsentation----------------
.ORG START_ADDR
.DB "TI-82 Protecteur by PARIS C.",0

main:   CALL Title
;-------------------------------------------------------------------------
mainloop:
	HALT
	CALL GET_KEY			; GET the KEY
	CP 34				; Was 1 pressed?
	jr z,lock
	CP 26				; Was 2 pressed?
	jr z,newpass
	CP $37				; Was mode pressed?
        jp z,endpass                    ; If so, end
	jr mainloop

;------------Eteint et verifie le code------------------------------------
lock:   CALL Title
	CALL $07EA

	LD A,$FA
	LD (compt),a

        LD DE,$1A01
        LD HL,login
        CALL TXT

	LD DE,$1A40
        CALL check
	ld a,(flag)
	cp 0
	jr nz,lock
        jp endpass

;-----------Change le code------------------------------------------------
newpass:
        LD A,$FA
	LD (compt),a
	LD DE,$1A01
     	LD HL,oldpass			;Point HL at string
        CALL TXT

        CALL check
	ld a,(flag)
	cp 0
        jp nz,main
	LD DE,$2801
     	LD HL,newspass			;Point HL at string
        CALL TXT
        LD A,$FA
	LD (compt),a
	ld hl,password

newloop:
	HALT
	push hl
	CALL GET_KEY			; GET the KEY
	pop hl
	cp 0
	jr z,newloop
	ld (hl),a
	CP 9
	jr z,endnew

	push hl
	LD A,(compt)
	add A,6
	ld (compt),a
	ld E,A
	LD D,$30
     	LD HL,star			;Point HL at string
        CALL TXT

	ld bc,1
	pop hl

	add HL,bc
	ld a,(hl)
	CP 255
	jr nz,newloop
endnew:
        jp main

check:
	ld a,0
	ld (flag),a
	ld hl,password

checkloop:
	HALT
	push hl
	CALL GET_KEY			; GET the KEY
	pop hl
	cp 0
	jr z,checkloop
	ld b,(hl)
	cp b
	jr z,noflag
	ld d,a
	ld a,1
	ld (flag),a
	ld a,d

noflag:
	CP 9
	jr z,endpass

	push HL
	LD A,(compt)
	add A,6
	ld (compt),a
	ld E,A
	LD D,$21
     	LD HL,star			;Point HL at string
        CALL TXT

	ld bc,1
	pop hl
	add HL,bc
	ld a,(hl)

	CP 255
	jr nz,checkloop

endpass:
	ret
;-------------------------------------------------------------------------
TXT:    LD ($8215),DE			;Transfert dans $8215
     	ROM_CALL(D_ZM_STR)		;Call ROMCALL
	RET

Write_Mem:
	LD (HL),$FF
	inc hl
	LD A,H
	CP B
	jr nz,Write_Mem
	LD A,L
	CP C
	jr nz,Write_Mem
	RET

Title:
        GRAPH_START			;Initialisation
	DI

	ld 	hl,$88B8		;CLEAR GRAPH_MEM
	ld 	de,$88B9
	ld 	bc,$2FF
	xor 	a
	ld 	(hl),a
	ldir

	LD HL,$88B8	;Coord1 du rectangle
	LD BC,$8924	;Coord2 du rectangle
        CALL Write_Mem

	LD HL,$89CC
	LD BC,$89D8
        CALL Write_Mem

	LD HL,$8B64
	LD BC,$8BB8
        CALL Write_Mem

        ROM_CALL(DISP_GRAPH)

        set 3,(IY+05)			;Mode Inverse
        LD DE,$0113			;Coordonnees
        LD HL,titre			;\    Chargement
        CALL TXT

        LD DE,$3906
        LD HL,nom			; Affichage
        CALL TXT
	res 3,(IY+05)			; RETOUR AU MODE NORMAL

        LD DE,$0901
        LD HL,option1
        CALL TXT

        LD DE,$1001
        LD HL,option2
        CALL TXT
	RET
;-------------------------------------------------------------------------
option1:
	.db	"1) Eteint et protege la TI-82",0

option2:
	.db	"2) Change le code",0

oldpass:
	.db	"Entrez l'ancien code:",0
	.db	"",0

newspass:
	.db	"Entrez le nouveau code:",0

login:
	.db	"Entrez votre code:",0

star:
	.db	"*",0

password:
	.db	9,9,9,9,9,255,0

titre:  .db "TI-82 PROTECTEUR",0

nom:    .db "-=* PARIS Christophe *=-",0

#INCLUDE "graph.inc"

.END
.END
.END
.END
