;	     S A F E - T - C A L C
;
;   v1.0 for ASH - TI-82 Assembly Shell
;
;             By Don Barnes
;
; (C) 1997
;
#INCLUDE "ti82.h"

;-----------------
; TEXT MEM STUFF
;-----------------

flag      = TEXT_MEM

;---------------------
; START OF ASH PROGRAM
;---------------------

.ORG START_ADDR
.DB "Safe-T-Calc   by Don Barnes",0


main:
	ROM_CALL(CLEARLCD)
	LD	HL,0
        LD      ($800C),HL

	set	3,(IY+05)
     	LD 	HL,safecalc		;Point HL at string
     	ROM_CALL(D_ZT_STR)		; Call ROMCALL
	res	3,(IY+05)
	ld	a,2
        ld      ($800C),a
     	ROM_CALL(D_ZT_STR)		; Call ROMCALL

mainloop:
	HALT
	CALL GET_KEY			; GET the KEY
	CP	34			; Was 1 pressed?
	jr z,lock
	CP	26			; Was 2 pressed?
	jr z,newpass
	CP	$37			; Was mode pressed?
	jr z,ending			; If so, end
	jr	mainloop

ending:
	RET

lock:
	CALL $07EA
	ld	HL,$0002
	ld	($800c),hl
     	LD HL,login			;Point HL at string
     	ROM_CALL(D_ZT_STR)		; Call ROMCALL
	LD	HL,$0003
	ld	($800c),hl
        CALL check
	ld	a,(flag)
	cp	0
	jr nz,lock
	jr z,ending
	
newpass:
     	LD HL,oldpass		;Point HL at string
     	ROM_CALL(D_ZT_STR)		; Call ROMCALL
        CALL check
	ld	a,(flag)
	cp	0
        jp nz,main
	LD	HL,$0006
	ld	($800c),hl
     	LD HL,newspass			;Point HL at string
     	ROM_CALL(D_ZT_STR)		; Call ROMCALL

	ld	hl,password

newloop:
	HALT
	push	hl
	CALL GET_KEY			; GET the KEY
	pop	hl
	cp	0
	jr	z,newloop
	ld	(hl),a
	CP	9
	jr	z,endnew

	push	hl
     	LD HL,star			;Point HL at string
     	ROM_CALL(D_ZT_STR)		; Call ROMCALL

	ld	bc,1
	pop	hl
	add	HL,bc
	ld	a,(hl)
	CP	255
	jr	nz,newloop
endnew:
	jp main

check:
	ld	a,0
	ld	(flag),a
	ld	hl,password

checkloop:
	HALT
	push	hl
	CALL GET_KEY			; GET the KEY
	pop	hl
	cp	0
	jr	z,checkloop
	ld	b,(hl)
	cp	b
	jr	z,noflag
	ld	d,a
	ld	a,1
	ld	(flag),a
	ld	a,d

noflag:
	CP	9
	jr	z,endpass

	push	hl
     	LD HL,star			;Point HL at string
     	ROM_CALL(D_ZT_STR)		; Call ROMCALL

	ld	bc,1
	pop	hl
	add	HL,bc
	ld	a,(hl)

	CP	255
	jr	nz,checkloop
endpass:
	ret

safecalc
	.db	"Safe-T-Calc v1.0"
	.db	"By Don Barnes   ",0
options:
	.db	"1) Lock TI-82   "
	.db	"2) Change Pass  ",0
oldpass:
	.db	"Type old pass:  ",0

newspass:
	.db	"Type new pass:  ",0
login:
	.db	"Type login pass:              ",0
star:
	.db	"*",0
password:
        .db     9,9,9,9,9,9,9,9,255,0
.END
.END
.END
.END
